﻿using System;
using System.IO; //fájlkezeléshez 
using System.Linq;
using System.Windows.Forms;

namespace LAB8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Fájlkezelés";
            button1.Text = "Feladatok generálása";
            button2.Text = "Feladatok megoldása";
        }

        //Feladatok kitalálása és kimentése megadott fájlba
        private void button1_Click(object sender, EventArgs e)
        {
            // Mentés dialógusablak létrehozása
            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.FileName = "";
            // szűrés *.txt fájlokra
            saveFileDialog.Filter = "Matek feladatok|*.txt";
            // dialógusablak megnyitása és gombnyomás vizsgálata
            // ha a Mégse gomb kerül megnyomásra, akkor kilépünk 
            if (saveFileDialog.ShowDialog() == DialogResult.Cancel) return;

            // Szövegfájl létrehozása írásra
            StreamWriter sw = new StreamWriter(saveFileDialog.FileName);

            // lista ürítése
            listBox1.Items.Clear();

            //véletlenszám generátor 
            Random randi = new Random();

            //feladatok száma 10..100 közötti
            int db = randi.Next(10, 101);

            for (int i = 0; i < db; i++)
            {
                int szam1 = randi.Next(11);   //0..10 közötti számok          
                int szam2 = randi.Next(1, 11); //1..10 közötti számok (ne legyen 0 osztó)
                string[] muv = new string[4] { "+", "-", "*", "/" };
                int n = randi.Next(4);        //+ 0, - 1, * 2, / 3
                // feladat szövegének összeállítása
                string feladat = $"{szam1}{muv[n]}{szam2}=";
                // kiíratás a listába
                listBox1.Items.Add(feladat);
                // kiírás fájlba
                sw.WriteLine(feladat);
            }//for cikus vége

            // fájlírás kényszerítése
            sw.Flush();
            // fájl bezárása
            sw.Close();
        }

        //Feladatok beolvasása és megoldása
        private void button2_Click(object sender, EventArgs e)
        {
            // Megnyítás dialógusablak létrehozása
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.FileName = "";
            // szűrés *.txt fájlokra
            openFileDialog.Filter = "Matek feladatok|*.txt";
            // dialógusablak megnyitása és gombnyomás vizsgálata
            // ha a Mégse gomb kerül megnyomásra, akkor kilépünk 
            if (openFileDialog.ShowDialog() == DialogResult.Cancel) return;

            // Szövegfájl beolvasása
            StreamReader sr = new StreamReader(openFileDialog.FileName);
            // Szöveg fájl létrehozása a megoldás számára
            StreamWriter sw = new StreamWriter(openFileDialog.FileName + ".bak");

            //Lista ürítése
            listBox2.Items.Clear();

            // ciklus a szövegfájl sorainak beolvasására
            // a ciklus vége a fájl végével
            while (!sr.EndOfStream)
            {
                // 1 sor beolvasása a fájlból
                string sor = sr.ReadLine();
                // üres-e a sor?
                // ha üres, akkor nincs mit feldolgozni
                if (sor.Length == 0) continue;

                // részekre bontás
                string[] db = sor.Split('+', '-', '*', '/', '=');

                // számok kinyerése a szövegből
                int szam1 = Convert.ToInt32(db[0]);
                int szam2 = Convert.ToInt32(db[1]);

                // műveletek megkeresése és végrehajtása
                string eredmeny = sor.Substring(0, sor.IndexOf("=") + 1); //csak = jelig
                if (sor.Contains('+')) eredmeny += $"{szam1 + szam2}";
                if (sor.Contains('-')) eredmeny += $"{szam1 - szam2}";
                if (sor.Contains('*')) eredmeny += $"{szam1 * szam2}";
                if (sor.Contains('/')) eredmeny += $"{(double)szam1 / szam2:F2}";

                // eredmény megjelenítése
                listBox2.Items.Add(eredmeny);
                // eredmény kiírása fájlba
                sw.WriteLine(eredmeny);

            }//while vége

            // fájlok bezárása
            sr.Close();
            sw.Flush();
            sw.Close();

            // Eredeti fájl törlése
            File.Delete(openFileDialog.FileName);
            // Átmeneti fájl átnevezése
            File.Move(openFileDialog.FileName + ".bak", openFileDialog.FileName);
        }
    }
}
